/* The file operand_vs_variable,c 
 * containes a simple task which illustrates a difference between operands and 
 * variables 
 */
#define WHO_IS_REMAINED_ON_PIPE(a,b)({ \
int  __a = (a),                          \
     __b = (b),                          \
     __c = (__a) & (__b); __c; })

#define DECPOW_RETURN(d)({           \
unsigned long __d =(d), __k = 1;     \
   do{                               \
      while( (__d)-- ) (__k) *= 10;      \
  }while(0); __k; })

#define IS_DIGITAL(d)({              \
      int __d = (d);                 \
          ((__d) >= 0x30 && (__d) <= 0x39); })

#define STRLEN(s)({                         \
      char *__s = (char  *)(s); unsigned long __n = 0UL;    \
      do{                                   \
	 while( (s) && *(__s)++ ) (__n)++;  \
      }while(0); __n; })

#define RETCODE_MAX	255

static __inline__ unsigned long string_to_ul (const char *src)
{
    char                 *p = (char  *)src+STRLEN(src),
			 *d = (char  *)src;
    unsigned long   __retval = 0UL;

    while ( p-- != (char *)src && IS_DIGITAL(*p) ) {
       __retval += (unsigned long)(*d++ - 0x30) * DECPOW_RETURN((p)-(char *)src);
    }

    return __retval;
}

/*
 * run to shell as
 *               ./operand_vs_variable 240 90; echo "return code: $?" 
 */
int main ( int argc, char** argv )
{
 int retcode = RETCODE_MAX;
 static signed char new_entity = 0;/* qualifier static is used to be illustration of */
                                     /* the difference between operand and variable. */
   
 new_entity = ( argc != 3 ? RETCODE_MAX :
	                   WHO_IS_REMAINED_ON_PIPE ( 
                                          string_to_ul (*(argv+1)),    /* This is A */
                                          string_to_ul (*(argv+2))) ); /* This is B */
				 
  return (retcode=(new_entity < RETCODE_MAX ? new_entity : RETCODE_MAX ));  
}

/*eof*/

